{-# LANGUAGE GADTs, MultiParamTypeClasses #-}
{-# OPTIONS_GHC -Wall -fno-warn-name-shadowing #-}
module BoundLanguage(
 BoundLanguage(..),
 inBindingScope
) where

import Language

class (Language l) => BoundLanguage l t where
  bindingHook :: Context l from to -> t -> t


inBindingScope :: (BoundLanguage l t) => (a -> t) -> Cursor l x a -> t
inBindingScope fn (Cursor it ctx _) = foldUp (fn it) ctx

foldUp :: (BoundLanguage l t) => t -> Path l (Context l) a b -> t
foldUp t Stop = t
foldUp t (Step ctx nxt) = foldUp (bindingHook ctx t) nxt
